/* dq_insert - install DQ_NODE at proper place in deque */
#include "deque.h"
void dq_insert(dq, p, cmpfn)
	DQ_NODE *dq;
	DQ_NODE *p;
	int (*cmpfn)();		/* function for comparisons: neg, zero, or pos */
	{
	DQ_NODE *p2;

	if (DQ_IS_EMPTY(dq)				/* if deque was empty, */
		|| (*cmpfn)(p, DQ_FIRST(dq)) < 0) /* or if p comes first, */
		DQ_PUSH(dq, p);				/* push p onto front */
	else							/* else, p must sort after p2 */
		{
		EACH_DQ(dq, p2, DQ_NODE)	/* find where p belongs */
			{
			if (p2->right == dq)
				{ 					/* if end of deque, */
				DQ_APPEND(dq, p);	/* append p at rear of deque */
				break;
				}
			else if ((*cmpfn)(p, p2->right) < 0)
				{ 					/* if p sorts before p2->right */
				DQ_R_INSERT(p, p2);	/* insert after p2 */
				break;
				}
			}
		}
	}
